VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MapSMD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'------------------------------------------------------------------------------
'
'   ACTvZT[rX TvvO
'   MappleXC^tF[XNX
'
'   Copyrights (c) 2004-2005 Advanced Core Technologies, Inc. All rights reserved.
'
'   2005/03/04 Rev.1.00 RIN J
'
'------------------------------------------------------------------------------

Option Explicit

'------------------------------------------------------------------------------
'   Constants
'------------------------------------------------------------------------------

'   [Private]

'   n}Ɋւ郂[h
Private Const MAP_CONTROL_POINTSELECT As Long = 0                           '   H_I
Private Const MAP_CONTROL_GRABBER As Long = 1                               '   n}ړ
Private Const MAP_CONTROL_ZOOMIN As Long = 2                                '   g
Private Const MAP_CONTROL_ZOOMOUT As Long = 3                               '   k
'   gpACReLXg̕\x
Private Const TEXT_LEVEL_2 As Long = 1                                      '   x2
Private Const TEXT_LEVEL_4 As Long = 3                                      '   x4
'   gpACReLXg̔wiF/p`̓F
Private Const FILL_COLOR_TRANSPARENT As Long = -1                           '   F
'   n}̎
Private Const MAP_TYPE_JAPAN As Long = 70                                   '   {S}  (MappleX 4 ȍ~̂)
Private Const MAP_TYPE_LOCAL_1 As Long = 80                                 '   n}(1) (MappleX 4 ȍ~̂)
Private Const MAP_TYPE_LOCAL_2 As Long = 90                                 '   n}(2) (MappleX 4 ȍ~̂)
Private Const MAP_TYPE_WIDE As Long = 0                                     '   Ln}
Private Const MAP_TYPE_MIDDLE As Long = 1                                   '   n}
Private Const MAP_TYPE_DETAIL As Long = 2                                   '   ڍגn}
'   en}̍ŏ/őkڒl
Private Const MAP_TYPE_JAPAN_SCALE_MIN As Long = 2997387                    '   {S}̍ŏl
Private Const MAP_TYPE_JAPAN_SCALE_MAX As Long = 13700000                   '   {S}̍ől
Private Const MAP_TYPE_LOCAL_1_SCALE_MIN As Long = 1498701                  '   n}(1)̍ŏl
Private Const MAP_TYPE_LOCAL_1_SCALE_MAX As Long = 2997386                  '   n}(1)̍ől
Private Const MAP_TYPE_LOCAL_2_SCALE_MIN As Long = 360001                   '   n}(2)̍ŏl
Private Const MAP_TYPE_LOCAL_2_SCALE_MAX As Long = 1498700                  '   n}(2)̍ől
Private Const MAP_TYPE_WIDE_SCALE_MIN As Long = 50001                       '   Ln}̍ŏl
Private Const MAP_TYPE_WIDE_SCALE_MAX As Long = 360000                      '   Ln}̍ől
Private Const MAP_TYPE_MIDDLE_SCALE_MIN As Long = 10001                     '   n}̍ŏl
Private Const MAP_TYPE_MIDDLE_SCALE_MAX As Long = 50000                     '   n}̍ől
Private Const MAP_TYPE_DETAIL_SCALE_MIN As Long = 1000                      '   ڍגn}̍ŏl
Private Const MAP_TYPE_DETAIL_SCALE_MAX As Long = 10000                     '   ڍגn}̍ől
'   ACReLXg̕\x̍ŏ/ől
Private Const TEXT_LEVEL_MIN As Long = 0                                    '   x1
Private Const TEXT_LEVEL_MAX As Long = 5                                    '   x6
'   ACReLXg̕`X^C̍ŏ/ől
Private Const TEXT_STYLE_MIN As Long = 0                                    '   X^C0
Private Const TEXT_STYLE_MAX As Long = 7                                    '   X^C7
'   gpACReLXg̕`X^C
Private Const TEXT_STYLE_ONLY_ICON As Long = 1                              '   ACR̂
Private Const TEXT_STYLE_ONLY_LABEL As Long = 2                             '   x̂
'   gpACReLXg̃ACRhciO`VXj
Private Const TEXT_ICON_ID_POINT As Long = 79                               '   Point.ico79Ƃicondef.datt@Cɒ`
'   gpACReLXg̃x/|SȂǂ̓X^Cl
Private Const FILL_STYLE_NORMAL As Long = 0                                 '   ʏix^j
'   oH`Ŏgpłőm[h
Private Const POINTS_COUNT_MAX As Long = 300000                             '   ftHgl
'   ܐ/[g̐
Private Const LINE_WIDTH_DEFAULT As Long = 100                              '   ftHgl
'   n}̕\k
Private Const SCALE_DEFAULT As Long = 100000                                '   ftHgl
'   n}ӏXg̃Zp[^
Private Const MAP_DESIGN_LIST_SEPARATOR As String = ","                     '   J}gp
'   MappleX̃ReLXgj[ɓo^镶
Private Const CONTEXT_MENU_STRING_JAPAN As String = "k8001"        '   k8001
Private Const CONTEXT_MENU_STRING_LOCAL_1 As String = "k3001"      '   k3001
Private Const CONTEXT_MENU_STRING_LOCAL_2 As String = "k1501"      '   k1501
Private Const CONTEXT_MENU_STRING_WIDE_1 As String = "k201"        '   k201
Private Const CONTEXT_MENU_STRING_WIDE_2 As String = "k101"        '   k101
Private Const CONTEXT_MENU_STRING_MIDDLE_1 As String = "k51"       '   k51
Private Const CONTEXT_MENU_STRING_MIDDLE_2 As String = "k25番1"    '   k25番1
Private Const CONTEXT_MENU_STRING_DETAIL_1 As String = "k11"       '   k11
Private Const CONTEXT_MENU_STRING_DETAIL_2 As String = "k50001"      '   k50001
Private Const CONTEXT_MENU_STRING_DETAIL_3 As String = "k25001"      '   k25001
'   Œ胉x
Private Const AREA_START_POINT_STRING As String = "   START   "             '   B /  ̃X^[gn_


'------------------------------------------------------------------------------
'   Members
'------------------------------------------------------------------------------

'   [Private]

Private m_ObjMapX As MapX               '   MappleX ActiveX Rg[
Private m_MapControl As Long            '   n}Ɋւ郂[h
Private m_PointTextFillColor As Long    '   n_`̃eLXg\̔wiF
Private m_PointIconFillColor As Long    '   n_`̃ACR\̔wiF
Private m_PolygonFillColor As Long      '   |S`̓F
Private m_PolygonLineColorDonut As Long '   h[ic|S`̃CF

'------------------------------------------------------------------------------
'   Methods
'------------------------------------------------------------------------------

'   [Public]

'   C^[tFCX̏
'   p[^
'       axMapX  [IN]MappleX ActiveX Rg[
'   ߂l
'       Ȃ
Public Sub Initialize(ByVal axMapX As MapX)
    '   MappleX ActiveX Rg[̐ݒ
    Set m_ObjMapX = axMapX
    
    '   n}Ɋւ郂[h̐ݒ
    MapControl = MAP_CONTROL_POINTSELECT                                '   H_I ɐݒ
    '   ACReLXg̕\x̐ݒ
    TextLevel = TEXT_LEVEL_2                                            '   x2 ɐݒ
    '   ACReLXg̕F̐ݒ
    TextColor = RGB(255, 0, 0)                                          '   ԐF ɐݒ
    '   ACReLXg̕`X^C̐ݒ
    TextStyle = TEXT_STYLE_ONLY_LABEL                                   '   x̂ ɐݒ
    '   ACReLXg̃ACRID̐ݒ
    TextIconID = TEXT_ICON_ID_POINT                                     '   [U`ACR 79 ɐݒ
    '   ACReLXg̔wiX^C/p`̓X^C̐ݒ
    FillStyle = FILL_STYLE_NORMAL                                       '   ʏix^jɐݒ
    '   n_`̃eLXg\̔wiF̐ݒ
    PointTextFillColor = RGB(255, 255, 0)                               '   F ɐݒ
    '   n_`̃ACR\̔wiF̐ݒ
    PointIconFillColor = FILL_COLOR_TRANSPARENT                         '   F ɐݒ
    '   |S`̓F̐ݒ
    PolygonFillColor = FILL_COLOR_TRANSPARENT                           '   F ɐݒ
    '   ܐ/[g̐F̐ݒ
    LineColor = RGB(255, 0, 0)                                          '   ԐF ɐݒ
    '   ܐ/[g̐̐ݒ
    LineWidth = LINE_WIDTH_DEFAULT                                      '   ftHgl 100 ɐݒ

    '   n}̎ނƕ\kڒl̐ݒ
    SetScaleforSMD (SCALE_DEFAULT)                                      '   ftHgl 100000 ɐݒ

    ' ReLXgj[ɒn}̕\kڒl̐ݒ胁j[o^
    m_ObjMapX.SetContextMenu 1, CONTEXT_MENU_STRING_JAPAN, 1, 0         '   k8001
    m_ObjMapX.SetContextMenu 2, CONTEXT_MENU_STRING_LOCAL_1, 1, 0       '   k3001
    m_ObjMapX.SetContextMenu 3, CONTEXT_MENU_STRING_LOCAL_2, 1, 0       '   k1501
    m_ObjMapX.SetContextMenu 4, CONTEXT_MENU_STRING_WIDE_1, 1, 0        '   k201
    m_ObjMapX.SetContextMenu 5, CONTEXT_MENU_STRING_WIDE_2, 1, 0        '   k101
    m_ObjMapX.SetContextMenu 6, CONTEXT_MENU_STRING_MIDDLE_1, 1, 0      '   k51
    m_ObjMapX.SetContextMenu 7, CONTEXT_MENU_STRING_MIDDLE_2, 1, 0      '   k25番1
    m_ObjMapX.SetContextMenu 8, CONTEXT_MENU_STRING_DETAIL_1, 1, 0      '   k11
    m_ObjMapX.SetContextMenu 9, CONTEXT_MENU_STRING_DETAIL_2, 1, 0      '   k50001
    m_ObjMapX.SetContextMenu 10, CONTEXT_MENU_STRING_DETAIL_3, 1, 0     '   k25001
End Sub

'   [gvZ / ŒZ[gvZ ̃P[VA|Cg\̔z`悷
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`Ɏs
Friend Function DrawDistCalcRoute( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim i As Long               '   JE^
    Dim nCustomID As Long       '   JX^ ID
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx

    DrawDistCalcRoute = False   '   ߂l̏

    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If

    '   ACReLXg̐ݒ
    nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID

    '   oH̕`̊Jn
    For i = 0 To nPntCount - 1
        nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
        nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
        DrawDistCalcRoute = m_ObjMapX.AddPolyLine( _
        nCustomID, _
        nLon, _
        nLat, _
        0 _
        )
        '   oH̕`ɎsĂȂH
        If DrawDistCalcRoute = False Then
            MsgBox "|Cg\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
    Next

    '   n_̕`̊Jn
    For i = 0 To nLocCount - 1
        lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + Format(Locs(i).nDist, "###,##0")
        DrawDistCalcRoute = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
        '   n_̕`ɎsĂȂH
        If DrawDistCalcRoute = False Then
            MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
    Next
End Function

'   B / vZ ̃P[VA|Cg\̔z`悷
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'       Param       [IN]R}hp[^
'   ߂l
'       True    P[VA|Cg\̔z̕`ɐ
'       False   P[VA|Cg\̔z̕`ɐ
Friend Function DrawDistCalcArea( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long, _
                                    ByRef Param As Param _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim i As Long               '   JE^
    Dim nCustomID As Long       '   JX^ ID
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx

    DrawDistCalcArea = False    '   ߂l̏

    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If

    '   ACReLXg̐ݒ
    m_ObjMapX.SetFillColor (PolygonFillColor)   '   |S`̓Fݒ
    nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID

    '   |S̕`̊Jn
    
    For i = 0 To nPntCount - 1
        nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
        nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
        '   |S̕`ɎsĂȂH
        If DrawDistCalcArea = False Then
            MsgBox "|Cg\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
            Exit Function
        End If
    Next

    '   n_̕`̊Jn(P[Vꍇ)
    If nLocCount > 1 Then
        For i = 0 To nLocCount - 1
            lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + Format(Locs(i).nDist, "###,##0")
            DrawDistCalcArea = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
            '   n_̕`ɎsĂȂH
            If DrawDistCalcArea = False Then
                MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
        Next
    End If

    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcArea = DrawPoint(CDbl(Param.szCalcArea_StartLon), CDbl(Param.szCalcArea_StartLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcArea = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

' 2009/01/28 MORO add
'   B / vZ(Ver2) ̃|Cg\̔z`悷
'   p[^
'       Pnts        [IN]|Cg\̔z̐擪vf
'       nPntCount   [IN]|Cg\̔z̗vf
'       CAParam     [IN]CalcAreaR}hp[^
'   ߂l
'       True    |Cg\̔z̕`ɐ
'       False   |Cg\̔z̕`ɐ
Friend Function DrawDistCalcAreaCA( _
                                    ByRef Pnts() As Pnt, ByVal nPntCount As Long, _
                                    ByRef CAParam As CAParam _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim i As Long               '   JE^
    Dim nCustomID As Long       '   JX^ ID
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx
    Dim nDonutFlg As Long       '   h[ic|SptO

    DrawDistCalcAreaCA = False    '   ߂l̏

    '   ő|Cg𒴂ĂȂH
    If nPntCount > POINTS_COUNT_MAX Then
        Exit Function
    End If

    If nPntCount > 0 Then
        '   ACReLXg̐ݒ
        m_ObjMapX.SetFillColor (PolygonFillColor)   '   |S`̓Fݒ
        nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID
    
        '   |S̕`̊Jn
        nDonutFlg = 0
        For i = 0 To nPntCount - 1
            nLon = CLng(CDbl(Pnts(i).szLon) * 3600000#) '   ox
            nLat = CLng(CDbl(Pnts(i).szLat) * 3600000#) '   ܓx
                    
            If nLon = 0 And nLat = 0 Then
                nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID
                
                ' h[ic|Sp
                If nDonutFlg = 0 Then
                    nDonutFlg = 1
                    LineColor = RGB(255, 0, 0)              '   ԐF ɐݒ
                Else
                    nDonutFlg = 0
                    LineColor = RGB(0, 0, 255)              '   F ɐݒ
                End If
            Else
            
                DrawDistCalcAreaCA = m_ObjMapX.AddPolyLine( _
                nCustomID, _
                nLon, _
                nLat, _
                0 _
                )
                
                ' h[ictO߂
                nDonutFlg = 0
            End If
            
            '   |S̕`ɎsĂȂH
            If DrawDistCalcAreaCA = False Then
                MsgBox "|Cg\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
        Next
    End If
    
    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcAreaCA = DrawPoint(CDbl(CAParam.StartGeoPnt.szLon), CDbl(CAParam.StartGeoPnt.szLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcAreaCA = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   ГꊇvZ ̃P[V\̔z`悷
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'       COWParam    [IN]CalcOneWayR}hp[^
'   ߂l
'       True    P[V\̔z̕`ɐ
'       False   P[V\̔z̕`ɐ
Friend Function DrawDistCalcAreaCOW( _
                                    ByRef Locs() As Loc, ByVal nLocCount As Long, _
                                    ByRef COWParam As COWParam _
                                    ) As Boolean
    Dim lpszLabal As String     '   `悷郉x
    Dim i As Long               '   JE^
    Dim nCustomID As Long       '   JX^ ID
    Dim nLon As Long            '   `悷ox
    Dim nLat As Long            '   `悷ܓx

    DrawDistCalcAreaCOW = False    '   ߂l̏

    '   ACReLXg̐ݒ
    m_ObjMapX.SetFillColor (PolygonFillColor)   '   |S`̓Fݒ
    nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID

    '   n_̕`̊Jn(P[Vꍇ)
    If nLocCount > 1 Then
        For i = 0 To nLocCount - 1
            lpszLabal = (i + 1) & "  " & Locs(i).nTime & "" + "  " + Format(Locs(i).nDist, "###,##0")
            DrawDistCalcAreaCOW = DrawPoint(CDbl(Locs(i).szLon), CDbl(Locs(i).szLat), lpszLabal)
            '   n_̕`ɎsĂȂH
            If DrawDistCalcAreaCOW = False Then
                MsgBox "P[V\̔z̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
                Exit Function
            End If
        Next
    End If

    '   n_̕`̊Jn(X^[gn_)
    lpszLabal = AREA_START_POINT_STRING
    DrawDistCalcAreaCOW = DrawPoint(CDbl(COWParam.StartGeoPnt.szLon), CDbl(COWParam.StartGeoPnt.szLat), lpszLabal)
    '   n_̕`ɎsĂȂH
    If DrawDistCalcAreaCOW = False Then
        MsgBox "X^[gn_̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function
' 2009/01/28 MORO end



'   n}ɓH_\
'   p[^
'       Locs        [IN]P[V\̔z̐擪vf
'       nLocCount   [IN]P[V\̔z̗vf
'   ߂l
'       True    H_̕\ɐ
'       False   H_̕\Ɏs
Friend Function DrawLastLoc(ByRef Locs() As Loc, ByVal nLocCount As Long) As Boolean
    Dim nElement As Long    '   QƂvfԍ

    nElement = nLocCount - 1    '   Ō̗vfԍ̎擾

    '   n_̕`̊Jn(Ō̒n_)
    DrawLastLoc = DrawPoint(CDbl(Locs(nElement).szLon), CDbl(Locs(nElement).szLat), CStr(nElement + 1))
    '   n_̕`ɎsĂȂH
    If DrawLastLoc = False Then
        MsgBox "P[V\̂̕`Ɏs܂B", vbOKOnly + vbCritical, "G["
    End If
End Function

'   n}̒S_ݒ肷
'   p[^
'       nLon    [IN]S_ɐݒ肷ox
'       nLat    [IN]S_ɐݒ肷ܓx
'   ߂l
'       Ȃ
Public Sub PanMap(ByVal nLon As Long, ByVal nLat As Long)
    m_ObjMapX.SetPosition nLon, nLat
End Sub

'   n}̃IuWFNgSč폜
'   p[^
'       Ȃ
'   ߂l
'       Ȃ
Public Sub ClearMap()
    m_ObjMapX.DeleteAllCustom
End Sub

'   n}̕\kڒln}̎ނƕ\kڒlݒ肷( SMD p̕`kڏ)
'   p[^
'       nScale  [IN]k X1  X
'   ߂l
'       Ȃ
Public Sub SetScaleforSMD(ByVal nScale As Long)
    '   n}̕\kڒl؂ւn}̎ނI
    Select Case nScale
        Case MAP_TYPE_DETAIL_SCALE_MIN To MAP_TYPE_DETAIL_SCALE_MAX     '   ڍגn}
            MapType = MAP_TYPE_DETAIL
        Case MAP_TYPE_MIDDLE_SCALE_MIN To MAP_TYPE_MIDDLE_SCALE_MAX     '   n}
            MapType = MAP_TYPE_MIDDLE
        Case MAP_TYPE_WIDE_SCALE_MIN To MAP_TYPE_WIDE_SCALE_MAX         '   Ln}
            MapType = MAP_TYPE_WIDE
        Case MAP_TYPE_LOCAL_2_SCALE_MIN To MAP_TYPE_LOCAL_2_SCALE_MAX   '   n}(2)
            MapType = MAP_TYPE_LOCAL_2
        Case MAP_TYPE_LOCAL_1_SCALE_MIN To MAP_TYPE_LOCAL_1_SCALE_MAX   '   n}(1)
            MapType = MAP_TYPE_LOCAL_1
        Case MAP_TYPE_JAPAN_SCALE_MIN To MAP_TYPE_JAPAN_SCALE_MAX       '   {S}
            MapType = MAP_TYPE_JAPAN
        Case Else                                                       '   ȊO
            Exit Sub
    End Select
    MapScale = nScale   '   n}̕\kڒlݒ
End Sub

'   n}ӏXg쐬
'   p[^
'       Ȃ
'   ߂l
'       n}ӏXg
'   l
'       n}ӏXǵu,v؂Œn}ӏA񃊃XgB
'       n}ӏ݂ȂAn}ӏ̎擾Ɏsꍇ́A
'       ̕񂪕Ԃ܂B
Public Function GetMapDesignList() As String
    Dim i As Integer                '   JE^
    Dim nMapDesignCount As Integer  '   n}ӏ
    Dim lpszMapDesignName As String '   n}ӏ擾pobt@
    Dim lpszMapDesignList As String '   n}ӏXg
    Dim MapDesignArray() As String  '   n}ӏi[z

    '   
    lpszMapDesignName = ""          '   n}ӏ擾pobt@
    lpszMapDesignList = ""          '   n}ӏXg

    '   n}ӏ̎擾
    nMapDesignCount = m_ObjMapX.GetMdiGroupCount()

    '   n}ӏ݂͑邩H
    If nMapDesignCount = 0 Then
        GetMapDesignList = ""
        Exit Function
    End If

    '   n}ӏi[zmۂ
    ReDim MapDesignArray(nMapDesignCount - 1)

    '   n}ӏ擾Ĕz̊evfɐݒ肷
    For i = 0 To nMapDesignCount - 1
        '   n}ӏ̎擾ɐH
        If m_ObjMapX.GetMdiGroupName(i, lpszMapDesignName) = False Then
            GetMapDesignList = ""
            Exit Function
        End If

        '   n}ӏz̗vfɐݒ
        MapDesignArray(i) = lpszMapDesignName
    Next

    '   z񂩂n}ӏXg쐬
    lpszMapDesignList = Join(MapDesignArray, MAP_DESIGN_LIST_SEPARATOR)

    '   쐬
    GetMapDesignList = lpszMapDesignList
End Function

'   [Private]

'   n}ɒn_`悷
'   p[^
'       ldX         [IN]`悷n_̌ox
'       ldY         [IN]`悷n_̈ܓx
'       lpszLabel   [IN]`悷郉x
'   ߂l
'       True    n_̕`ɐ
'       False   n_̕`Ɏs
Private Function DrawPoint(ByVal ldX As Double, ByVal ldY As Double, ByVal lpszLabel As String) As Boolean
    Dim nLon As Long        '   ox
    Dim nLat As Long        '   ܓx
    Dim nCustomID As Long   '   JX^ ID

    DrawPoint = False       '   ߂l̏

    '   ox/ܓxl̕ϊ
    nLon = CLng(ldX * 3600000#)     '   ox
    nLat = CLng(ldY * 3600000#)     '   ܓx

    '   ACReLXg̐ݒ
    TextStyle = TEXT_STYLE_ONLY_LABEL                               '   eLXg\̂߂ x̂ ɐݒ
    m_ObjMapX.SetFillColor (PointTextFillColor)                     '   eLXg\̔wiFݒ
    nCustomID = m_ObjMapX.GetCustomCount() + 1                      '   JX^ ID

    DrawPoint = m_ObjMapX.AddText(nCustomID, nLon, nLat, lpszLabel) '   eLXg\̎s

    '   eLXg\ɐH
    If DrawPoint = True Then
        '   ACReLXg̐ݒ
        TextStyle = TEXT_STYLE_ONLY_ICON                            '   ACR\̂߂ ACR̂ ɐݒ
        m_ObjMapX.SetFillColor (PointIconFillColor)                 '   ACR\̔wiFݒ
        nCustomID = m_ObjMapX.GetCustomCount() + 1                  '   JX^ ID

        DrawPoint = m_ObjMapX.AddText(nCustomID, nLon, nLat, "")    '   ACR\̎s
    End If
End Function

'------------------------------------------------------------------------------
'   Properties
'------------------------------------------------------------------------------

'   [Public]

'   n}Ɋւ郂[h擾/ݒ肷
'   擾
Public Property Get MapControl() As Long
    MapControl = m_MapControl
End Property
'   ݒ
Public Property Let MapControl(ByVal nMapControl As Long)
    '   [hl MappleX Rg[̒n}샂[hƃJ[\̐ݒs
    Select Case nMapControl
        Case MAP_CONTROL_POINTSELECT    '   H_I
            m_ObjMapX.ToolType = 1  '    JX^I[h / J[\
        Case MAP_CONTROL_GRABBER        '   n}ړ
            m_ObjMapX.ToolType = 0  '    n}ړ[h / Oo[J[\
        Case MAP_CONTROL_ZOOMIN         '   g
            m_ObjMapX.ToolType = 2  '    ACReLXg̓[h / \J[\
        Case MAP_CONTROL_ZOOMOUT        '   k
            m_ObjMapX.ToolType = 2  '    ACReLXg̓[h / \J[\
        Case Else                       '   ȊO
            Exit Property
    End Select
    m_MapControl = nMapControl          '   [hl̐ݒ
End Property

'   n}̎ނ擾/ݒ肷
'   擾
Public Property Get MapType() As Long
    MapType = m_ObjMapX.GetMapType()
End Property
'   ݒ
Public Property Let MapType(ByVal nMapType As Long)
    '   n}̎ނ̒l͐ȒlH
    If (nMapType = MAP_TYPE_JAPAN) Or _
       (nMapType = MAP_TYPE_LOCAL_1) Or _
       (nMapType = MAP_TYPE_LOCAL_2) Or _
       (nMapType = MAP_TYPE_WIDE) Or _
       (nMapType = MAP_TYPE_MIDDLE) Or _
       (nMapType = MAP_TYPE_DETAIL) Then
        '   n}̎ނ̐ݒ
        m_ObjMapX.SetMapType (nMapType)
    End If
End Property

'   n}̕\kڒl擾/ݒ肷
'   擾
Public Property Get MapScale() As Long
    MapScale = m_ObjMapX.GetScale()
End Property
'   ݒ
Public Property Let MapScale(ByVal nScale As Long)
    '   ݂̒n}̎ނƏƍāAݒ肷kڒl͐ȒlH
    Select Case nScale
        Case MAP_TYPE_DETAIL_SCALE_MIN To MAP_TYPE_DETAIL_SCALE_MAX     '   ڍגn}
            If MapType <> MAP_TYPE_DETAIL Then
                Exit Property
            End If
        Case MAP_TYPE_MIDDLE_SCALE_MIN To MAP_TYPE_MIDDLE_SCALE_MAX     '   n}
            If MapType <> MAP_TYPE_MIDDLE Then
                Exit Property
            End If
        Case MAP_TYPE_WIDE_SCALE_MIN To MAP_TYPE_WIDE_SCALE_MAX         '   Ln}
            If MapType <> MAP_TYPE_WIDE Then
                Exit Property
            End If
        Case MAP_TYPE_LOCAL_2_SCALE_MIN To MAP_TYPE_LOCAL_2_SCALE_MAX   '   n}(2)
            If MapType <> MAP_TYPE_LOCAL_2 Then
                Exit Property
            End If
        Case MAP_TYPE_LOCAL_1_SCALE_MIN To MAP_TYPE_LOCAL_1_SCALE_MAX   '   n}(1)
            If MapType <> MAP_TYPE_LOCAL_1 Then
                Exit Property
            End If
        Case MAP_TYPE_JAPAN_SCALE_MIN To MAP_TYPE_JAPAN_SCALE_MAX       '   {S}
            If MapType <> MAP_TYPE_JAPAN Then
                Exit Property
            End If
        Case Else                                                       '   ȊO
            Exit Property
    End Select
    '   kڒl̐ݒ
    m_ObjMapX.SetScale (nScale)
End Property

'   n}ӏ擾/ݒ肷
'   擾
Public Property Get MapDesign() As String
'   擾
    Dim lpszMapDesignPath As String
    Dim lpszMapDesignName As String

    '   ݎgpĂn}ӏ擾
    m_ObjMapX.GetMdiGroup lpszMapDesignPath, lpszMapDesignName
    '   ݂̒n}ӏԂ
    MapDesign = lpszMapDesignName
End Property
'   ݒ
Public Property Let MapDesign(ByVal lpszMapDesignName As String)
    '   w肵n}ӏɐݒ
    m_ObjMapX.SetMdiGroup (lpszMapDesignName)
End Property

'   ACReLXg̕\x擾/ݒ肷
'   擾
Public Property Get TextLevel() As Long
    TextLevel = m_ObjMapX.GetTextLevel()
End Property
'   ݒ
Public Property Let TextLevel(ByVal nLevel As Long)
    '   ACReLXg̕\xl͈͓̔H
    If (nLevel >= TEXT_LEVEL_MIN) And (nLevel <= TEXT_LEVEL_MAX) Then
        m_ObjMapX.SetTextLevel (nLevel)
    End If
End Property

'   ACReLXg̕F擾/ݒ肷
'   擾
Public Property Get TextColor() As Long
    TextColor = m_ObjMapX.GetTextColor()
End Property
'   ݒ
Public Property Let TextColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_ObjMapX.SetTextColor (nRGB)
    End If
End Property

'   ACReLXg̕`X^C擾/ݒ肷
'   擾
Public Property Get TextStyle() As Long
    TextStyle = m_ObjMapX.GetTextStyle()
End Property
'   ݒ
Public Property Let TextStyle(ByVal nTextStyle As Long)
    '   ACReLXg̕`X^Cl͈̔͂H
    If (nTextStyle >= TEXT_STYLE_MIN) And (nTextStyle <= TEXT_STYLE_MAX) Then
        m_ObjMapX.SetTextStyle (nTextStyle)
    End If
End Property

'   ACReLXg̃ACRID擾/ݒ肷
'   擾
Public Property Get TextIconID() As Long
    TextIconID = m_ObjMapX.GetTextIconID()
End Property
'   ݒ
Public Property Let TextIconID(ByVal nTextIconID As Long)
    '   ACR ID l͈͓̔H
    If (nTextIconID >= 0) And (nTextIconID < m_ObjMapX.GetIconCount()) Then
        m_ObjMapX.SetTextIconID (nTextIconID)
    End If
End Property

'   ACReLXg̔wiX^C/p`̓X^C擾/ݒ肷
'   擾
Public Property Get FillStyle() As Long
    FillStyle = m_ObjMapX.GetFillStyle()
End Property
'   ݒ
Public Property Let FillStyle(ByVal nFillStyle As Long)
    '   X^Cl͈͓̔H
    If (nFillStyle >= 0) And (nFillStyle < m_ObjMapX.GetFillStyleCount()) Then
        m_ObjMapX.SetFillStyle (nFillStyle)
    End If
End Property

'   n_`̃eLXg\̔wiF擾/ݒ肷
'   擾
Public Property Get PointTextFillColor() As Long
    PointTextFillColor = m_PointTextFillColor
End Property
'   ݒ
Public Property Let PointTextFillColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= FILL_COLOR_TRANSPARENT) And (nRGB <= RGB(255, 255, 255)) Then
        m_PointTextFillColor = nRGB
    End If
End Property

'   n_`̃ACR\̔wiF擾/ݒ肷
'   擾
Public Property Get PointIconFillColor() As Long
    PointIconFillColor = m_PointIconFillColor
End Property
'   ݒ
Public Property Let PointIconFillColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
     If (nRGB >= FILL_COLOR_TRANSPARENT) And (nRGB <= RGB(255, 255, 255)) Then
         m_PointIconFillColor = nRGB
     End If
End Property

'   |S`̓F擾/ݒ肷
'   擾
Public Property Get PolygonFillColor() As Long
    PolygonFillColor = m_PolygonFillColor
End Property
'   ݒ
Public Property Let PolygonFillColor(ByVal nRGB As Long)
    '   RGB l͈͓̔H
    If (nRGB >= FILL_COLOR_TRANSPARENT) And (nRGB <= RGB(255, 255, 255)) Then
        m_PolygonFillColor = nRGB
    End If
End Property

'   ܐ/[g̐F擾/ݒ肷
'   擾
Public Property Get LineColor() As Long
    LineColor = m_ObjMapX.GetLineColor()
End Property
'   ݒ
Public Property Let LineColor(ByVal nRGB As Long)
    '   RGBl͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_ObjMapX.SetLineColor (nRGB)
    End If
End Property

'   ܐ/[g̐F擾/ݒ肷(h[ic|S)
'   擾
Public Property Get LineColorDonut() As Long
    LineColorDonut = m_PolygonLineColorDonut
End Property
'   ݒ
Public Property Let LineColorDonut(ByVal nRGB As Long)
    '   RGBl͈͓̔H
    If (nRGB >= RGB(0, 0, 0)) And (nRGB <= RGB(255, 255, 255)) Then
        m_PolygonLineColorDonut = nRGB
    End If
End Property


'   ܐ/[g̐擾/ݒ肷
'   擾
Public Property Get LineWidth() As Long
    LineWidth = m_ObjMapX.GetLineWidth()
End Property
'   ݒ
Public Property Let LineWidth(nLineWidth As Long)
    m_ObjMapX.SetLineWidth (nLineWidth)
End Property

'   End of Source
